<app-common-modal *ngIf="modalId" [id]="modalId" size="large" (modalClose)="reset()">

    <span headerTitle>Add User Input Parameter</span>
    <div body class="d-flex flex-wrap app-modal-body">
        <div class="d-flex flex-column param-cont key quater" [ngClass]="error.key ? 'has-error' : ''">
            <label class="font-regu-14 color-grey33">Parameter Name</label>
            <input placeholder="Enter unique name" [(ngModel)]="paramModel.key" (ngModelChange)="handleChange('key')" type="text">
            <span class="error">{{error.key}}</span>
        </div>
        <div class="d-flex flex-column param-cont type quater">
            <label class="font-regu-14 color-grey33">Parameter Type</label>
            <div class="d-flex">
                <div>
                    <input [(ngModel)]="paramModel.type" [value]="false" type="radio" name="typegroup"
                        id="nongroupTypeParam" (ngModelChange)="handleChange('type')"/>
                    <label class="font-regu-14 color-grey33" for="nongroupTypeParam">Individual</label>
                </div>
                <div class="ml-3">
                    <input [(ngModel)]="paramModel.type" (ngModelChange)="handleChange('type')" [value]="true" type="radio" name="typegroup"
                        id="groupTypeParam" />
                    <label class="font-regu-14 color-grey33" for="groupTypeParam">Group</label>
                </div>
            </div>
        </div>
        <div class="d-flex flex-column param-cont quater">
            <label class="font-regu-14 color-grey33">Appearance</label>
            <app-dropdown placeholder="select" [options]="paramModel.predefinedClasses" (valueChange)="handleChange('class')" [(value)]="paramModel.class">
            </app-dropdown>
        </div>
        <div class="d-flex flex-column param-cont group quater" *ngIf="!paramModel.type">
            <label class="font-regu-14 color-grey33">Assign to group</label>
            <app-dropdown placeholder="select" [(value)]="paramModel.groupName" (valueChange)="handleChange('groupName')" [options]="paramModel.groups"></app-dropdown>
        </div>
        <div class="d-flex flex-column param-cont half">
            <label class="font-regu-14 color-grey33">Heading Text</label>
            <input [(ngModel)]="paramModel.heading" (ngModelChange)="handleChange('heading')" type="text">
        </div>
        <div class="d-flex flex-column param-cont half">
            <label class="font-regu-14 color-grey33">Title Text</label>
            <input [(ngModel)]="paramModel.title" (ngModelChange)="handleChange('title')" type="text">
        </div>
        <div class="d-flex flex-column param-cont half">
            <label class="font-regu-14 color-grey33">Hint Text</label>
            <input [(ngModel)]="paramModel.hint" (ngModelChange)="handleChange('hint')" type="text">
        </div>
        <div class="d-flex flex-column param-cont half" *ngIf="!paramModel.type">
            <label class="font-regu-14 color-grey33">Interaction Type</label>
            <div class="d-flex">
                <div>
                    <input [(ngModel)]="paramModel.interaction" (ngModelChange)="handleChange('interaction')" [value]="1" type="radio" name="interaction"
                        id="input" />
                    <label class="font-regu-14 color-grey33" for="input">Input Text</label>
                </div>
                <div class="ml-3">
                    <input [(ngModel)]="paramModel.interaction" (ngModelChange)="handleChange('interaction')" [value]="0" type="radio" name="interaction"
                        id="dropdown" />
                    <label class="font-regu-14 color-grey33" for="dropdown">Dropdown</label>
                </div>

            </div>
        </div>
        <div class="d-flex flex-column param-cont quater" *ngIf="!paramModel.type">
            <label class="font-regu-14 color-grey33">Default Value</label>
            <input [(ngModel)]="paramModel.default" (ngModelChange)="handleChange('default')" type="text">
        </div>
        <div class="d-flex flex-column param-cont quater" *ngIf="!paramModel.type">
            <label class="font-regu-14 color-grey33">Place Holder Text</label>
            <input [(ngModel)]="paramModel.placeholder" (ngModelChange)="handleChange('placeholder')" type="text">
        </div>
        <div class="d-flex flex-column param-cont half" *ngIf="!paramModel.type && paramModel.interaction === 0">
            <label class="font-regu-14 color-grey33">Options</label>
            <input [(ngModel)]="paramModel.options" (ngModelChange)="handleChange('options')" type="text">
        </div>

        <div class="d-flex flex-column param-cont actions"
            *ngIf="!paramModel.type && paramModel.interaction === 0 && paramModel.definedOptions.length">
            <label class="font-regu-14 color-grey33 heading">Associated Actions</label>
            <div class="d-flex">
                <div class="d-flex flex-column quater">
                    <label class="font-regu-14 color-grey33">On Value</label>
                    <app-dropdown placeholder="Select value to define actions" [options]="paramModel.definedOptions"
                        [(value)]="selectedValueForActions" (valueChange)="showActionsForValue($event)">
                    </app-dropdown>
                </div>
                <div class="d-flex flex-column flex-fill justify-content-end">
                    <div class="d-flex" *ngIf="actionsForSourceValue.length">
                        <div class="d-flex flex-column third">
                            <label class="font-regu-14 color-grey33">Parameter</label>
                        </div>
                        <div class="d-flex flex-column third">
                            <label class="font-regu-14 color-grey33">Action</label>
                        </div>
                    </div>
                    <div *ngFor="let a of actionsForSourceValue; let i = index;" class="d-flex mb-3">
                        <div class="d-flex flex-column third">
                            <app-dropdown placeholder="Select parameter to apply action." [options]="allParameterKeys"
                                [(value)]="a.target" (valueChange)="handleChange('target',i, $event)">
                            </app-dropdown>
                        </div>
                        <div class="d-flex flex-column third">
                            <app-dropdown placeholder="Choose action to apply " [options]="paramModel.predefinedActions"
                                [(value)]="a.action" (valueChange)="handleChange('action', i, $event)">
                            </app-dropdown>
                        </div>
                        <label (click)="removeAction(i)"
                            class="third ml-auto align-self-end remove-action">[Remove]</label>
                    </div>
                    <div class="d-flex flex-column justify-content-end" *ngIf="selectedValueForActions.length">
                        <!-- <div>&nbsp;</div> -->
                        <div class="d-flex align-items-end">
                            <label class="third info" *ngIf="actionsForSourceValue.length === 0">[No actions are defined
                                for
                                selected value. Press
                                Add button to define.]</label>
                            <div [ngClass]="actionsForSourceValue.length === 0 ? 'third' : 'third ml-auto'">
                                <button (click)="addAction()"
                                    class="app-btn">{{actionsForSourceValue.length === 0 ? 'Add[+]' : 'Add More[+]'}}</button>
                            </div>
                        </div>

                    </div>
                </div>
            </div>
        </div>
        <div class="d-flex flex-column param-cont half" *ngIf="!paramModel.type && paramModel.interaction === 1">
            <label class="font-regu-14 color-grey33">Should Validate Against</label>
            <div class="d-flex mb-3" *ngFor="let v of paramModel.validations; let i = index;">
                <div>
                    <input [(ngModel)]="v.regex" (ngModelChange)="handleChange('validations')" (blur)="updateValidation(i,{regex: $event.target.value})" type="text"
                        placeholder="Enter regular expression" />
                </div>
                <div class="ml-1">
                    <input [(ngModel)]="v.error" (ngModelChange)="handleChange('validations')" (blur)="updateValidation(i,{error: $event.target.value})" type="text"
                        placeholder="Enter respective error message">
                </div>
                <div class="ml-1">
                    <label (click)="removeValidation(i)" class="remove-action">[Remove]</label>
                </div>
            </div>
            <div class="d-flex">
                <label class="flex-fill info" *ngIf="paramModel.validations.length === 0">[No validations are defined.
                    Press
                    Add button to define.]</label>
                <div [ngClass]="paramModel.validations.length ? 'third ml-auto' : 'third'">
                    <button (click)="addValidation()"
                        class="app-btn">{{paramModel.validations.length === 0 ? 'Add[+]' : 'Add More[+]'}}</button>
                </div>
            </div>
        </div>
        <div class="d-flex flex-column param-cont quater" *ngIf="!paramModel.type">
            <label class="font-regu-14 color-grey33">Enabled</label>
            <div class="d-flex">
                <div>
                    <input [(ngModel)]="paramModel.enabled" (ngModelChange)="handleChange('enabled')" [value]="true" type="radio" name="enabled"
                        id="enabledParam" />
                    <label class="font-regu-14 color-grey33" for="enabledParam">Yes</label>
                </div>
                <div class="ml-3">
                    <input [(ngModel)]="paramModel.enabled" (ngModelChange)="handleChange('enabled')" [value]="false" type="radio" name="enabled"
                        id="disabledParam" />
                    <label class="font-regu-14 color-grey33" for="disabledParam">No</label>
                </div>

            </div>
        </div>
        <div class="d-flex flex-column param-cont quater">
            <label class="font-regu-14 color-grey33">Hidden</label>
            <div class="d-flex">
                <div>
                    <input [(ngModel)]="paramModel.hidden" (ngModelChange)="handleChange('hidden')" [value]="true" type="radio" name="hidden" id="hiddenParam" />
                    <label class="font-regu-14 color-grey33" for="hiddenParam">Yes</label>
                </div>
                <div class="ml-3">
                    <input [(ngModel)]="paramModel.hidden" (ngModelChange)="handleChange('hidden')" [value]="false" type="radio" name="hidden"
                        id="visibleParam" />
                    <label class="font-regu-14 color-grey33" for="visibleParam">No</label>
                </div>

            </div>
        </div>
        <div class="d-flex flex-column param-cont quater" *ngIf="!paramModel.type">
            <label class="font-regu-14 color-grey33">Required</label>
            <div class="d-flex">
                <div>
                    <input [(ngModel)]="paramModel.required" (ngModelChange)="handleChange('required')" [value]="true" type="radio" name="required"
                        id="requiredParam" />
                    <label class="font-regu-14 color-grey33" for="requiredParam">Yes</label>
                </div>
                <div class="ml-3">
                    <input [(ngModel)]="paramModel.required" (ngModelChange)="handleChange('required')" [value]="false" type="radio" name="required"
                        id="optionalParam" />
                    <label class="font-regu-14 color-grey33" for="optionalParam">No</label>
                </div>
            </div>
        </div>
    </div>
    <div footer>
        <button [disabled]="!enableSubmit" class="app-btn-filled app-btn-size-100" (click)="onSubmit()">Submit</button>
    </div>

</app-common-modal>